var $AdfRichAutomation$$ = {$_severityMap$:[]};
$AdfRichAutomation$$.$_severityMap$["1000"] = "SEVERE";
$AdfRichAutomation$$.$_severityMap$["900"] = "WARNING";
$AdfRichAutomation$$.$_severityMap$["800"] = "INFO";
$AdfRichAutomation$$.$LOGGER$ = new $AdfLogger$$("AdfRichAutomationLogger", new $AdfBufferedLogWriter$$, $AdfLogger$$.INFO);
$goog$exportSymbol$$("AdfRichAutomation.LOGGER", $AdfRichAutomation$$.$LOGGER$);
$AdfRichAutomation$$.$LOGGER$.register();
$AdfRichAutomation$$.$subIdToDomElToSubId$ = function $$AdfRichAutomation$$$$subIdToDomElToSubId$$($componentLocator$$, $subIds$$) {
  var $component$$221$$ = $AdfPage$$.$PAGE$.$findComponentByAbsoluteLocator$($componentLocator$$);
  if (!$component$$221$$) {
    return "[FAILURE] Cannot find component using locator" + $componentLocator$$;
  }
  if (!$component$$221$$.$getPeer$ || !$component$$221$$.$getPeer$()) {
    return "[FAILURE] No peer found for component" + $component$$221$$;
  }
  for (var $peer$$29$$ = $component$$221$$.$getPeer$(), $returnString$$ = "", $locator$$6_subIdEl$$, $subId$$7$$, $i$$103$$ = 0;$i$$103$$ < $subIds$$.length;$i$$103$$++) {
    $subId$$7$$ = $subIds$$[$i$$103$$], ($locator$$6_subIdEl$$ = $peer$$29$$.$getSubIdDomElement$($component$$221$$, $subIds$$[$i$$103$$])) ? ($locator$$6_subIdEl$$ = $AdfRichUIPeer$$.$getLocatorByDomElement$($locator$$6_subIdEl$$)) && $locator$$6_subIdEl$$ == $componentLocator$$ + "#" + $subId$$7$$ || ($returnString$$ += "[FAILURE]  SubId to DOM to SubId failed for component: '" + $componentLocator$$ + "', subId: '" + $subId$$7$$ + "', returned locator: '" + $locator$$6_subIdEl$$ + "'. Component peer provided a valid DOM, but the subId obtained from that DOM did not match.\n") : 
    $returnString$$ += "[FAILURE] SubId to DOM to SubId failed for component '" + $componentLocator$$ + "', subId '" + $subId$$7$$ + "'. Component peer did not provide a valid DOM for the sub id.\n";
  }
  return "" == $returnString$$ ? null : $returnString$$;
};
$goog$exportSymbol$$("AdfRichAutomation.subIdToDomElToSubId", $AdfRichAutomation$$.$subIdToDomElToSubId$);
$AdfRichAutomation$$.$subIdToDomEl$ = function $$AdfRichAutomation$$$$subIdToDomEl$$($componentLocator$$1$$, $subIds$$1$$) {
  var $component$$222$$ = $AdfPage$$.$PAGE$.$findComponentByAbsoluteLocator$($componentLocator$$1$$);
  if (!$component$$222$$) {
    return "[FAILURE] Cannot find component using locator" + $componentLocator$$1$$;
  }
  if (!$component$$222$$.$getPeer$ || !$component$$222$$.$getPeer$()) {
    return "[FAILURE] No peer found for component" + $component$$222$$;
  }
  for (var $peer$$30$$ = $component$$222$$.$getPeer$(), $returnString$$1$$ = "", $subId$$8$$, $subIdEl$$1$$, $i$$104$$ = 0;$i$$104$$ < $subIds$$1$$.length;$i$$104$$++) {
    $subId$$8$$ = $subIds$$1$$[$i$$104$$], ($subIdEl$$1$$ = $peer$$30$$.$getSubIdDomElement$($component$$222$$, $subIds$$1$$[$i$$104$$])) || ($returnString$$1$$ += "[FAILURE] SubId to DOM failed for component '" + $componentLocator$$1$$ + "', subId '" + $subId$$8$$ + "'. Component peer did not provide a valid DOM for the sub id.\n");
  }
  return "" == $returnString$$1$$ ? null : $returnString$$1$$;
};
$goog$exportSymbol$$("AdfRichAutomation.subIdToDomEl", $AdfRichAutomation$$.$subIdToDomEl$);
$AdfRichAutomation$$.$locateElementByRich$ = function $$AdfRichAutomation$$$$locateElementByRich$$($locatorString$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Enter AdfRichAutomation.locateElementByRich");
  var $componentLocator$$2_locatedElement$$ = $locatorString$$, $subId$$9$$, $component$$223_startIndex$$3$$ = $locatorString$$.indexOf("#");
  -1 < $component$$223_startIndex$$3$$ && ($componentLocator$$2_locatedElement$$ = $locatorString$$.substring(0, $component$$223_startIndex$$3$$), $subId$$9$$ = $locatorString$$.substring($component$$223_startIndex$$3$$ + 1));
  var $fallback$$ = !1, $page$$14_peer$$31$$ = window.$AdfPage$.$PAGE$, $component$$223_startIndex$$3$$ = $page$$14_peer$$31$$.$findComponentByComplexLocator$($componentLocator$$2_locatedElement$$), $logger$$1$$ = $AdfRichAutomation$$.$LOGGER$;
  $component$$223_startIndex$$3$$ || ($component$$223_startIndex$$3$$ = $page$$14_peer$$31$$.$findComponentOrAncestorByAbsoluteLocator$($componentLocator$$2_locatedElement$$), $fallback$$ = !0, $logger$$1$$.info("AdfRichAutomation.locateElementByRich - falling back to: ", $component$$223_startIndex$$3$$, " for ", $locatorString$$));
  return $component$$223_startIndex$$3$$ ? ($page$$14_peer$$31$$ = $component$$223_startIndex$$3$$.$getPeer$(), $fallback$$ ? ($componentLocator$$2_locatedElement$$ = $page$$14_peer$$31$$.$getFallbackDomElement$($component$$223_startIndex$$3$$, $componentLocator$$2_locatedElement$$, $subId$$9$$)) ? $logger$$1$$.info("AdfRichAutomation.locateElementByRich - found fallback subid DOM element for locator:", $locatorString$$, " on component:", $component$$223_startIndex$$3$$) : $logger$$1$$.warning("AdfRichAutomation.locateElementByRich - fallback subId DOM Element not found for locator:", 
  $locatorString$$, " on component:", $component$$223_startIndex$$3$$) : $subId$$9$$ ? ($componentLocator$$2_locatedElement$$ = $page$$14_peer$$31$$.$getSubIdDomElement$($component$$223_startIndex$$3$$, $subId$$9$$)) ? $logger$$1$$.info("AdfRichAutomation.locateElementByRich - found subid dom element for locator:", $locatorString$$) : $logger$$1$$.warning("AdfRichAutomation.locateElementByRich - subIdElement not found for locator:", $locatorString$$) : ($componentLocator$$2_locatedElement$$ = window.$AdfRichUIPeer$.$getDomElementForComponent$($component$$223_startIndex$$3$$), 
  $logger$$1$$.info("AdfRichAutomation.locateElementByRich - found dom element for locator:", $locatorString$$)), $componentLocator$$2_locatedElement$$) : null;
};
$goog$exportSymbol$$("AdfRichAutomation.locateElementByRich", $AdfRichAutomation$$.$locateElementByRich$);
$AdfRichAutomation$$.$getWaitForRichPageFnName$ = function $$AdfRichAutomation$$$$getWaitForRichPageFnName$$() {
  $AdfRichAutomation$$.$LOGGER$.info("Enter AdfRichAutomation.getWaitForRichPageFnName");
  var $pprNavOptions$$ = window.$AdfPage$.$PAGE$.$getPPRNavigationOptions$();
  if (0 != $pprNavOptions$$) {
    if ($pprNavOptions$$ & 2) {
      return $AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.getWaitForRichPageFnName - PPR nav always"), "return AdfRichAutomation.waitForPagePPRNavAlways()";
    }
    $AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.getWaitForRichPageFnName - PPR nav sometimes");
    return "return AdfRichAutomation.waitForPagePPRNavSometimes()";
  }
  $AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.getWaitForRichPageFnName - PPR nav off");
  return "return AdfRichAutomation.waitForPagePPRNavOff()";
};
$goog$exportSymbol$$("AdfRichAutomation.getWaitForRichPageFnName", $AdfRichAutomation$$.$getWaitForRichPageFnName$);
$AdfRichAutomation$$.$waitForPagePPRNavAlways$ = function $$AdfRichAutomation$$$$waitForPagePPRNavAlways$$() {
  $AdfRichAutomation$$.$LOGGER$.info("Enter AdfRichAutomation.waitForPagePPRNavAlways");
  try {
    return window.$AdfPage$.$PAGE$.$isSynchronizedWithServer$();
  } catch ($e$$74$$) {
    return !1;
  }
};
$goog$exportSymbol$$("AdfRichAutomation.waitForPagePPRNavAlways", $AdfRichAutomation$$.$waitForPagePPRNavAlways$);
$AdfRichAutomation$$.$waitForPagePPRNavSometimes$ = function $$AdfRichAutomation$$$$waitForPagePPRNavSometimes$$() {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.waitForPagePPRNavSometimes");
  return window.$AdfPage$.$PAGE$.$_inAppNavigationFlag$ ? this.$waitForPagePPRNavOff$() : this.$waitForPagePPRNavAlways$();
};
$goog$exportSymbol$$("AdfRichAutomation.waitForPagePPRNavSometimes", $AdfRichAutomation$$.$waitForPagePPRNavSometimes$);
$AdfRichAutomation$$.$waitForPagePPRNavOff$ = function $$AdfRichAutomation$$$$waitForPagePPRNavOff$$() {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.waitForPagePPRNavOff");
  try {
    return window.$AdfPage$.$PAGE$.$isPageFullyLoaded$();
  } catch ($e$$75$$) {
    return !1;
  }
};
$goog$exportSymbol$$("AdfRichAutomation.waitForPagePPRNavOff", $AdfRichAutomation$$.$waitForPagePPRNavOff$);
$AdfRichAutomation$$.$cancelPopup$ = function $$AdfRichAutomation$$$$cancelPopup$$($id$$218$$) {
  return $AdfAutomationUtils$$.$cancelPopup$($id$$218$$);
};
$goog$exportSymbol$$("AdfRichAutomation.cancelPopup", $AdfRichAutomation$$.$cancelPopup$);
$AdfRichAutomation$$.$getRichDialogInfo$ = function $$AdfRichAutomation$$$$getRichDialogInfo$$($dialogId$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.getRichDialogInfo");
  var $state$$7$$ = void 0, $infoArray$$ = [], $state$$7$$ = window.$AdfAutomationUtils$.$getRichDialogServiceState$($dialogId$$);
  $dialogId$$ ? $AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.getRichDialogInfo - getting peer state with: ", $dialogId$$) : $AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.getRichDialogInfo - getting last peer state.");
  $state$$7$$ || $AdfRichAutomation$$.$_logSevereAndThrow$("AdfRichAutomation.getRichDialogInfo - no peer state.");
  $state$$7$$.popupId ? ($AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.getRichDialogInfo - setting up info array for inline popup."), $infoArray$$.push("inline"), $infoArray$$.push($state$$7$$.popupId), $infoArray$$.push($state$$7$$.frameName), $infoArray$$.push($state$$7$$.panelWindowId)) : $state$$7$$.$windowName$ && ($AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.getRichDialogInfo - setting up info array for window popup."), $infoArray$$.push("window"), $infoArray$$.push($state$$7$$.windowName));
  $infoArray$$.push($state$$7$$.launchSourceId);
  return $infoArray$$;
};
$goog$exportSymbol$$("AdfRichAutomation.getRichDialogInfo", $AdfRichAutomation$$.$getRichDialogInfo$);
$AdfRichAutomation$$.$getInlineWindowDomId$ = function $$AdfRichAutomation$$$$getInlineWindowDomId$$($clientId$$22_popup$$1$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.getInlineDialogTitle");
  return ($clientId$$22_popup$$1$$ = this.$getRichComponent$($clientId$$22_popup$$1$$)) ? $clientId$$22_popup$$1$$.$getProperty$("_panelWindowId") : null;
};
$goog$exportSymbol$$("AdfRichAutomation.getInlineWindowDomId", $AdfRichAutomation$$.$getInlineWindowDomId$);
$AdfRichAutomation$$.$waitForRichInlineDialogLaunch$ = function $$AdfRichAutomation$$$$waitForRichInlineDialogLaunch$$($clientId$$23_popup$$2$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.waitForRichInlineDialogLaunch");
  var $isPopupVisible$$ = !1;
  ($clientId$$23_popup$$2$$ = this.$getRichComponent$($clientId$$23_popup$$2$$)) && ($isPopupVisible$$ = $clientId$$23_popup$$2$$.$isPopupVisible$());
  return $isPopupVisible$$;
};
$goog$exportSymbol$$("AdfRichAutomation.waitForRichInlineDialogLaunch", $AdfRichAutomation$$.$waitForRichInlineDialogLaunch$);
$AdfRichAutomation$$.$getAllRichDialogIds$ = function $$AdfRichAutomation$$$$getAllRichDialogIds$$() {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.getAllRichDialogIds");
  var $ids$$ = $AdfAutomationUtils$$.$getRichDialogServiceAllIds$();
  $AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.getAllRichDialogIds - returning all rich dialog ids.");
  return $ids$$;
};
$goog$exportSymbol$$("AdfRichAutomation.getAllRichDialogIds", $AdfRichAutomation$$.$getAllRichDialogIds$);
$AdfRichAutomation$$.$getRichComponent$ = function $$AdfRichAutomation$$$$getRichComponent$$($clientId$$24$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.getRichComponent");
  var $component$$224$$ = window.$AdfPage$.$PAGE$.$findComponent$($clientId$$24$$);
  $component$$224$$ || $AdfRichAutomation$$.$LOGGER$.warning("AdfRichAutomation.getRichComponent - component not found for clientId: ", $clientId$$24$$);
  return $component$$224$$;
};
$goog$exportSymbol$$("AdfRichAutomation.getRichComponent", $AdfRichAutomation$$.$getRichComponent$);
$AdfRichAutomation$$.$getRichComponentByElement$ = function $$AdfRichAutomation$$$$getRichComponentByElement$$($element$$144$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.getRichComponentByElement");
  var $component$$225$$ = window.$AdfRichUIPeer$.$getFirstAncestorComponent$($element$$144$$);
  $component$$225$$ || $AdfRichAutomation$$.$LOGGER$.warning("AdfRichAutomation.getRichComponentByElement - No ADF component located in the ancestry of dom element: ", $element$$144$$);
  return $component$$225$$;
};
$goog$exportSymbol$$("AdfRichAutomation.getRichComponentByElement", $AdfRichAutomation$$.$getRichComponentByElement$);
$AdfRichAutomation$$.$getRichComponentType$ = function $$AdfRichAutomation$$$$getRichComponentType$$($component$$226_el$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.getRichComponentType");
  return $component$$226_el$$ ? ($component$$226_el$$ = window.$AdfRichUIPeer$.$getFirstAncestorComponent$($component$$226_el$$)) && "function" === typeof $component$$226_el$$.getComponentType ? $component$$226_el$$.getComponentType() : null : null;
};
$goog$exportSymbol$$("AdfRichAutomation.getRichComponentType", $AdfRichAutomation$$.$getRichComponentType$);
$AdfRichAutomation$$.$getRichComponentProperty$ = function $$AdfRichAutomation$$$$getRichComponentProperty$$($el$$1$$, $attrName$$9$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.getRichComponentProperty");
  var $richComponent$$ = this.$getRichComponentByElement$($el$$1$$);
  if ($richComponent$$) {
    return $richComponent$$.$getProperty$($attrName$$9$$);
  }
  $AdfRichAutomation$$.$_logSevereAndThrow$("AdfRichAutomation.getRichComponentProperty - No ADF component located in the ancestry of dom element : " + element);
};
$goog$exportSymbol$$("AdfRichAutomation.getRichComponentProperty", $AdfRichAutomation$$.$getRichComponentProperty$);
$AdfRichAutomation$$.$getRichComponentProperties$ = function $$AdfRichAutomation$$$$getRichComponentProperties$$($el$$2$$, $attrNames$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.getRichComponentProperties");
  var $richComponent$$1$$ = this.$getRichComponentByElement$($el$$2$$), $retArr$$ = [], $record$$8$$, $propertyName$$33$$;
  if ($richComponent$$1$$) {
    for (var $argLength$$ = $attrNames$$.length, $i$$105$$ = 0;$i$$105$$ < $argLength$$;$i$$105$$++) {
      $propertyName$$33$$ = $attrNames$$[$i$$105$$], $record$$8$$ = {}, $record$$8$$.name = $propertyName$$33$$, $record$$8$$.value = $richComponent$$1$$.$getProperty$($propertyName$$33$$), $retArr$$.push($record$$8$$);
    }
    return $retArr$$;
  }
  $AdfRichAutomation$$.$_logSevereAndThrow$("AdfRichAutomation.getRichComponentProperties - No ADF component located in the ancestry of dom element : " + element);
};
$goog$exportSymbol$$("AdfRichAutomation.getRichComponentProperties", $AdfRichAutomation$$.$getRichComponentProperties$);
$AdfRichAutomation$$.$setRichComponentProperty$ = function $$AdfRichAutomation$$$$setRichComponentProperty$$($el$$3_richComponent$$2$$, $propertyName$$34$$, $value$$148$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.setRichComponentProperty");
  if ($el$$3_richComponent$$2$$ = this.$getRichComponentByElement$($el$$3_richComponent$$2$$)) {
    return $AdfUIComponent$$.$isSecureProperty$($el$$3_richComponent$$2$$, $propertyName$$34$$) ? "##SECURE_PROPERTY_ERROR##" : $el$$3_richComponent$$2$$.setProperty($propertyName$$34$$, $value$$148$$);
  }
  $AdfRichAutomation$$.$_logSevereAndThrow$("AdfRichAutomation.setRichComponentProperty - No ADF component located in the ancestry of dom element : " + element);
};
$goog$exportSymbol$$("AdfRichAutomation.setRichComponentProperty", $AdfRichAutomation$$.$setRichComponentProperty$);
$AdfRichAutomation$$.$invokeRichComponentFunction$ = function $$AdfRichAutomation$$$$invokeRichComponentFunction$$($el$$4_richComponent$$3$$, $functionName$$3$$, $args$$180$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.invokeRichComponentFunction");
  if ($el$$4_richComponent$$3$$ = this.$getRichComponentByElement$($el$$4_richComponent$$3$$)) {
    var $func$$11$$ = $el$$4_richComponent$$3$$[$functionName$$3$$], $isIE$$ = $AdfRichAutomation$$.$_isInternetExplorer$();
    if ("function" == typeof $func$$11$$ || $isIE$$ && "object" == typeof $func$$11$$) {
      return $isIE$$ && window.$AdfCollections$ && window.$AdfCollections$.$cloneArray$($args$$180$$), $func$$11$$.apply($el$$4_richComponent$$3$$, $args$$180$$);
    }
    $AdfRichAutomation$$.$_logSevereAndThrow$("AdfRichAutomation.invokeRichComponentFunction - no function found by name: " + $functionName$$3$$);
  }
  $AdfRichAutomation$$.$_logSevereAndThrow$("AdfRichAutomation.invokeRichComponentFunction - No ADF component located in the ancestry of dom element : " + element);
};
$goog$exportSymbol$$("AdfRichAutomation.invokeRichComponentFunction", $AdfRichAutomation$$.$invokeRichComponentFunction$);
$AdfRichAutomation$$.$invokeRichComponentFunctionChain$ = function $$AdfRichAutomation$$$$invokeRichComponentFunctionChain$$($el$$5$$, $args$$181$$) {
  $AdfRichAutomation$$.$LOGGER$.info("Entering AdfRichAutomation.invokeRichComponentFunctionChain");
  var $fargs$$1_result$$12$$ = void 0, $target$$88$$ = this.$getRichComponentByElement$($el$$5$$);
  if ($target$$88$$) {
    for (var $argCount$$4$$ = $args$$181$$.length, $i$$106$$ = 0;$i$$106$$ < $argCount$$4$$;) {
      for (var $functionName$$4$$ = $args$$181$$[$i$$106$$++], $func$$12_functionArgCount$$ = $args$$181$$[$i$$106$$++], $functionArgs$$1$$ = [], $isIE$$1_j$$9$$ = 0;$isIE$$1_j$$9$$ < $func$$12_functionArgCount$$;$isIE$$1_j$$9$$++) {
        $functionArgs$$1$$.push($args$$181$$[$i$$106$$++]);
      }
      $AdfRichAutomation$$.$LOGGER$.info("AdfRichAutomation.invokeRichComponentFunctionChain - processing function: ", $functionName$$4$$, ", argCount: ", $func$$12_functionArgCount$$, ", args: ", $functionArgs$$1$$);
      $func$$12_functionArgCount$$ = $target$$88$$[$functionName$$4$$];
      $isIE$$1_j$$9$$ = $AdfRichAutomation$$.$_isInternetExplorer$();
      "function" == typeof $func$$12_functionArgCount$$ || $isIE$$1_j$$9$$ && "object" == typeof $func$$12_functionArgCount$$ ? ($fargs$$1_result$$12$$ = $functionArgs$$1$$, $isIE$$1_j$$9$$ && window.$AdfCollections$ && ($fargs$$1_result$$12$$ = window.$AdfCollections$.$cloneArray$($functionArgs$$1$$)), $fargs$$1_result$$12$$ = $func$$12_functionArgCount$$.apply($target$$88$$, $fargs$$1_result$$12$$)) : (msg = "AdfRichAutomation.invokeRichComponentFunctionChain - no function found by name: " + $functionName$$4$$, 
      $AdfRichAutomation$$.$_logSevereAndThrow$(msg));
      $target$$88$$ = $fargs$$1_result$$12$$;
    }
  } else {
    msg = "AdfRichAutomation.invokeRichComponentFunctionChain - No ADF component located in the ancestry of dom element : " + element, $AdfRichAutomation$$.$_logSevereAndThrow$(msg);
  }
  return $fargs$$1_result$$12$$;
};
$goog$exportSymbol$$("AdfRichAutomation.invokeRichComponentFunctionChain", $AdfRichAutomation$$.$invokeRichComponentFunctionChain$);
$AdfRichAutomation$$.$getAndClearLogMessages$ = function $$AdfRichAutomation$$$$getAndClearLogMessages$$($level$$20_logLevelNeeded$$) {
  $level$$20_logLevelNeeded$$ = $AdfRichAutomation$$.$_translateLogLevel$($level$$20_logLevelNeeded$$);
  for (var $logRecords$$2$$ = $AdfRichAutomation$$.$LOGGER$.$getLogWriter$().$getLogRecords$(), $log$$1$$ = [], $i$$107$$ = 0;$i$$107$$ < $logRecords$$2$$.length;$i$$107$$++) {
    var $logRecord$$20$$ = $logRecords$$2$$[$i$$107$$];
    $logRecord$$20$$.level >= $level$$20_logLevelNeeded$$ && $log$$1$$.push(this.$_getSeverity$($logRecord$$20$$.level) + " : " + $logRecord$$20$$.message);
  }
  $AdfRichAutomation$$.$LOGGER$.$getLogWriter$().$Clear$();
  return $log$$1$$;
};
$goog$exportSymbol$$("AdfRichAutomation.getAndClearLogMessages", $AdfRichAutomation$$.$getAndClearLogMessages$);
$AdfRichAutomation$$.$getElementPageBounds$ = function $$AdfRichAutomation$$$$getElementPageBounds$$($el$$6_pb$$) {
  $AdfRichAutomation$$.$_checkElement$($el$$6_pb$$, "AdfRichAutomation.getElementPageBounds");
  $el$$6_pb$$ = window.$AdfAgent$.$AGENT$.$getElementPageBounds$($el$$6_pb$$);
  return $el$$6_pb$$.top + "," + $el$$6_pb$$.right + "," + $el$$6_pb$$.left + "," + $el$$6_pb$$.bottom;
};
$goog$exportSymbol$$("AdfRichAutomation.getElementPageBounds", $AdfRichAutomation$$.$getElementPageBounds$);
$AdfRichAutomation$$.$getBodyBounds$ = function $$AdfRichAutomation$$$$getBodyBounds$$() {
  var $agent$$33_pb$$1$$ = window.$AdfAgent$.$AGENT$, $agent$$33_pb$$1$$ = $agent$$33_pb$$1$$.$getElementPageBounds$($agent$$33_pb$$1$$.$getDomDocument$().body);
  return $agent$$33_pb$$1$$.top + "," + $agent$$33_pb$$1$$.right + "," + $agent$$33_pb$$1$$.left + "," + $agent$$33_pb$$1$$.bottom;
};
$goog$exportSymbol$$("AdfRichAutomation.getBodyBounds", $AdfRichAutomation$$.$getBodyBounds$);
$AdfRichAutomation$$.getComputedStyle = function $$AdfRichAutomation$$$getComputedStyle$($cs_el$$7$$) {
  $AdfRichAutomation$$.$_checkElement$($cs_el$$7$$, "AdfRichAutomation.getComputedStyle");
  $cs_el$$7$$ = $AdfAgent$$.$AGENT$.getComputedStyle($cs_el$$7$$);
  var $computedStyle$$1$$ = "", $recordSeparator$$ = String.fromCharCode(30), $nameValueSeparator$$ = String.fromCharCode(31);
  if (null == $cs_el$$7$$.length) {
    for (var $name$$82$$ in $cs_el$$7$$) {
      0 < $computedStyle$$1$$.length && ($computedStyle$$1$$ += $recordSeparator$$);
      var $i$$108_styleName$$ = $name$$82$$.replace(/([A-Z])/g, "-$1").toLowerCase(), $styleValue$$1$$ = $cs_el$$7$$[$name$$82$$];
      if (null == $styleValue$$1$$ || "" == $styleValue$$1$$) {
        $styleValue$$1$$ = "undefined";
      }
      "font-weight" == $i$$108_styleName$$ && "700" == $styleValue$$1$$ && ($styleValue$$1$$ = "bold");
      $computedStyle$$1$$ += $i$$108_styleName$$ + $nameValueSeparator$$ + $styleValue$$1$$;
    }
  } else {
    for ($i$$108_styleName$$ = 0;$i$$108_styleName$$ < $cs_el$$7$$.length;++$i$$108_styleName$$) {
      0 < $computedStyle$$1$$.length && ($computedStyle$$1$$ += $recordSeparator$$);
      $name$$82$$ = $cs_el$$7$$.item($i$$108_styleName$$);
      $styleValue$$1$$ = $cs_el$$7$$.getPropertyValue($name$$82$$);
      if (null == $styleValue$$1$$ || "" == $styleValue$$1$$) {
        $styleValue$$1$$ = "undefined";
      }
      $computedStyle$$1$$ += $name$$82$$ + $nameValueSeparator$$ + $styleValue$$1$$;
    }
  }
  return $computedStyle$$1$$;
};
$goog$exportSymbol$$("AdfRichAutomation.getComputedStyle", $AdfRichAutomation$$.getComputedStyle);
$AdfRichAutomation$$.$queueCachedPollEvents$ = function $$AdfRichAutomation$$$$queueCachedPollEvents$$() {
  window.$AdfAutomationUtils$.$queueCachedPollEvents$();
};
$goog$exportSymbol$$("AdfRichAutomation.queueCachedPollEvents", $AdfRichAutomation$$.$queueCachedPollEvents$);
$AdfRichAutomation$$.$_getSeverity$ = function $$AdfRichAutomation$$$$_getSeverity$$($level$$21$$) {
  return $AdfRichAutomation$$.$_severityMap$["" + $level$$21$$];
};
$AdfRichAutomation$$.$_translateLogLevel$ = function $$AdfRichAutomation$$$$_translateLogLevel$$($level$$22$$) {
  return "INFO" == $level$$22$$ ? 800 : "WARN" == $level$$22$$ ? 900 : "ERROR" == $level$$22$$ ? 1E3 : Number.MAX_VALUE;
};
$AdfRichAutomation$$.$_isInternetExplorer$ = function $$AdfRichAutomation$$$$_isInternetExplorer$$() {
  return null != window.AdfIEAgent && $AdfAgent$$.$AGENT$ instanceof window.AdfIEAgent;
};
$AdfRichAutomation$$.$_checkElement$ = function $$AdfRichAutomation$$$$_checkElement$$($el$$8$$, $caller$$1$$) {
  $el$$8$$ || $AdfRichAutomation$$.$_logSevereAndThrow$($caller$$1$$ + " -  Element passed is null");
};
$AdfRichAutomation$$.$_logSevereAndThrow$ = function $$AdfRichAutomation$$$$_logSevereAndThrow$$($msg$$7$$) {
  $AdfRichAutomation$$.$LOGGER$.severe($msg$$7$$);
  throw $msg$$7$$;
};
